/// <reference types="node" />
import { OnApplicationBootstrap, OnApplicationShutdown, OnModuleInit } from '@nestjs/common';
import Democracy from 'democracy';
import { ConfigService } from '../config/config.service';
export declare class ClusterService extends Democracy implements OnModuleInit, OnApplicationBootstrap, OnApplicationShutdown {
    private readonly configService;
    private readonly config;
    private readonly logger;
    private clusterAdvertisement;
    private apiAdvertisement;
    private browser;
    private networkInterfaces;
    constructor(configService: ConfigService);
    onModuleInit(): void;
    onApplicationBootstrap(): void;
    onApplicationShutdown(): void;
    isMajorityLeader(): boolean;
    quorumReached(): boolean;
    broadcastPeers(): void;
    protected addMissingPeers(peers: string[][]): void;
    protected processEvent(msg: Buffer): this;
    protected checkBallots(candidate: string): this;
    protected startBonjourDiscovery(): void;
    private handleNodeDiscovery;
    private handleNodeAdded;
    private handleNodeRemoved;
    private handleNodeElected;
}
