"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAddrInfoDig = void 0;
const util = __importStar(require("util"));
const child_process_1 = require("child_process");
const os = __importStar(require("os"));
const execPromise = util.promisify(child_process_1.exec);
async function getAddrInfoDig(service, next) {
    if (service.host === 'localhost' || service.host === 'localhost.') {
        service.addresses = (service.addresses || []).concat(['127.0.0.1']);
        next();
        return;
    }
    try {
        const digOutput = await execPromise(`dig +short @224.0.0.251 -p 5353 -4 ${service.host}`);
        const addresses = digOutput.stdout.trim().split(os.EOL);
        service.addresses = (service.addresses || []).concat(addresses);
        next();
    }
    catch (e) {
        next(e);
    }
}
exports.getAddrInfoDig = getAddrInfoDig;
//# sourceMappingURL=resolvers.js.map