"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EntitiesController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const entity_dto_1 = require("./entity.dto");
const entities_service_1 = require("./entities.service");
const camera_1 = require("./camera");
const swagger_1 = require("@nestjs/swagger");
let EntitiesController = class EntitiesController {
    constructor(entitiesService) {
        this.entitiesService = entitiesService;
    }
    getAll() {
        return this.entitiesService
            .getAll()
            .filter((entity) => !(entity instanceof camera_1.Camera));
    }
};
__decorate([
    (0, common_1.Get)(),
    (0, swagger_1.ApiOperation)({
        summary: 'Retrieve all entities and their states',
        description: 'The entities will always match the schema, but may also provide some additional information depending on the integration they are from. Note that camera entities are filtered from this list.',
    }),
    (0, swagger_1.ApiOkResponse)({
        description: 'All registered entities are listed.',
        content: {
            'application/json': {
                schema: { type: 'array', items: { $ref: (0, swagger_1.getSchemaPath)(entity_dto_1.Entity) } },
                example: [
                    {
                        id: 'example-sensor',
                        name: 'Example Sensor',
                        distributed: true,
                        state: 'instance-name',
                        attributes: {
                            distance: 4.2,
                        },
                    },
                    {
                        id: 'example-switch',
                        name: 'Example Switch',
                        distributed: false,
                        state: true,
                        attributes: {},
                    },
                ],
            },
        },
    }),
    openapi.ApiResponse({ status: 200, type: [require("./entity.dto").Entity] }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Array)
], EntitiesController.prototype, "getAll", null);
EntitiesController = __decorate([
    (0, swagger_1.ApiTags)('entities'),
    (0, swagger_1.ApiExtraModels)(entity_dto_1.Entity),
    (0, common_1.Controller)('entities'),
    __metadata("design:paramtypes", [entities_service_1.EntitiesService])
], EntitiesController);
exports.EntitiesController = EntitiesController;
//# sourceMappingURL=entities.controller.js.map