"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BluetoothModule = void 0;
const common_1 = require("@nestjs/common");
const bluetooth_service_1 = require("./bluetooth.service");
const bluetooth_health_1 = require("./bluetooth.health");
const config_module_1 = require("../../config/config.module");
const status_module_1 = require("../../status/status.module");
const schedule_1 = require("@nestjs/schedule");
const nestjs_prometheus_1 = require("@willsoto/nestjs-prometheus");
let BluetoothModule = class BluetoothModule {
};
BluetoothModule = __decorate([
    (0, common_1.Module)({
        imports: [config_module_1.ConfigModule, status_module_1.StatusModule, schedule_1.ScheduleModule.forRoot()],
        providers: [
            bluetooth_service_1.BluetoothService,
            bluetooth_health_1.BluetoothHealthIndicator,
            (0, nestjs_prometheus_1.makeCounterProvider)({
                name: 'bluetooth_le_advertisements_received_count',
                help: 'Number of Bluetooth Low Energy advertisements that were detected by this device',
            }),
        ],
        exports: [bluetooth_service_1.BluetoothService],
    })
], BluetoothModule);
exports.BluetoothModule = BluetoothModule;
//# sourceMappingURL=bluetooth.module.js.map