"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RoomPresenceProxyHandler = void 0;
const room_presence_distance_sensor_1 = require("./room-presence-distance.sensor");
class RoomPresenceProxyHandler {
    constructor(deviceTracker, batterySensor) {
        this.deviceTracker = deviceTracker;
        this.batterySensor = batterySensor;
    }
    set(target, p, value) {
        target[p] = value;
        switch (p) {
            case 'state':
                this.deviceTracker.state =
                    value == room_presence_distance_sensor_1.STATE_NOT_HOME ? room_presence_distance_sensor_1.STATE_NOT_HOME : room_presence_distance_sensor_1.STATE_HOME;
                break;
            case 'batteryLevel':
                this.batterySensor.state = value;
                break;
        }
        return true;
    }
}
exports.RoomPresenceProxyHandler = RoomPresenceProxyHandler;
//# sourceMappingURL=room-presence.proxy.js.map