/// <reference types="node" />
import { Pixel } from './pixel';
import { Cluster } from './cluster';
import { HeatmapOptions } from './thermopile-occupancy.config';
export declare type RotationOption = 0 | 90 | 180 | 270;
export declare abstract class ThermopileOccupancyService {
    abstract getPixelTemperatures(): Promise<number[][]>;
    getCoordinates(temperatures: number[][], deltaThreshold: number): Promise<number[][]>;
    findRelevantPixels(data: number[][], deltaThreshold: number): Pixel[];
    clusterPixels(pixels: Pixel[]): Cluster[];
    isHeatmapAvailable(): boolean;
    generateHeatmap(temperatures: number[][], options?: HeatmapOptions, width?: number, height?: number): Promise<Buffer>;
    private static drawPixel;
    private static drawTemperature;
}
