"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BluetoothClassicConfig = void 0;
const jf = __importStar(require("joiful"));
const MAC_REXEP_STRING = '^([0-9a-fA-F]{2}[:]){5}([0-9a-fA-F]{2})$';
const MAC_REGEXP = new RegExp(MAC_REXEP_STRING);
const MAC_DEFAULT_REGEXP = new RegExp(MAC_REXEP_STRING + '|default');
const MAC_ERROR = '{#label} does not match the required MAC address format';
class BluetoothClassicEntityOverride {
}
__decorate([
    (jf.string().optional()),
    __metadata("design:type", String)
], BluetoothClassicEntityOverride.prototype, "id", void 0);
__decorate([
    (jf.string().optional()),
    __metadata("design:type", String)
], BluetoothClassicEntityOverride.prototype, "name", void 0);
class BluetoothClassicConfig {
    constructor() {
        this.addresses = [];
        this.rssiFactor = 1;
        this.hciDeviceId = 0;
        this.interval = 10;
        this.scanTimeLimit = 6;
        this.timeoutCycles = 2;
        this.preserveState = false;
        this.inquireFromStart = true;
        this.entityOverrides = {};
    }
}
__decorate([
    (jf.array({ elementClass: String }).custom(validateMACAddress).required()),
    __metadata("design:type", Array)
], BluetoothClassicConfig.prototype, "addresses", void 0);
__decorate([
    (jf.any().custom(validateMinRSSI).optional()),
    __metadata("design:type", Object)
], BluetoothClassicConfig.prototype, "minRssi", void 0);
__decorate([
    (jf.number().required()),
    __metadata("design:type", Object)
], BluetoothClassicConfig.prototype, "rssiFactor", void 0);
__decorate([
    (jf.number().integer().min(0).required()),
    __metadata("design:type", Object)
], BluetoothClassicConfig.prototype, "hciDeviceId", void 0);
__decorate([
    (jf.number().min(1).required()),
    __metadata("design:type", Object)
], BluetoothClassicConfig.prototype, "interval", void 0);
__decorate([
    (jf.number().min(1).required()),
    __metadata("design:type", Object)
], BluetoothClassicConfig.prototype, "scanTimeLimit", void 0);
__decorate([
    (jf.number().min(1).required()),
    __metadata("design:type", Object)
], BluetoothClassicConfig.prototype, "timeoutCycles", void 0);
__decorate([
    (jf.boolean().required()),
    __metadata("design:type", Object)
], BluetoothClassicConfig.prototype, "preserveState", void 0);
__decorate([
    (jf.boolean().required()),
    __metadata("design:type", Object)
], BluetoothClassicConfig.prototype, "inquireFromStart", void 0);
__decorate([
    (jf.object().custom(validateEntityOverrides).required()),
    __metadata("design:type", Object)
], BluetoothClassicConfig.prototype, "entityOverrides", void 0);
exports.BluetoothClassicConfig = BluetoothClassicConfig;
function validateMACAddress(options) {
    return options.joi
        .array()
        .items(options.joi.string().pattern(MAC_REGEXP).message(MAC_ERROR));
}
function validateMinRSSI(options) {
    return options.joi
        .alternatives()
        .try(options.joi.number().max(0), options.joi
        .object()
        .pattern(options.joi.string().pattern(MAC_DEFAULT_REGEXP), options.joi.number().max(0)));
}
function validateEntityOverrides(options) {
    return options.joi
        .object()
        .pattern(options.joi.string(), jf.getSchema(BluetoothClassicEntityOverride));
}
//# sourceMappingURL=bluetooth-classic.config.js.map