"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BluetoothLowEnergyPresenceSensor = void 0;
const room_presence_distance_sensor_1 = require("../../integration-support/room-presence/room-presence-distance.sensor");
class BluetoothLowEnergyMeasurement {
    constructor(rssi, measuredPower) {
        this.rssi = rssi;
        this.measuredPower = measuredPower;
    }
}
class BluetoothLowEnergyPresenceSensor extends room_presence_distance_sensor_1.RoomPresenceDistanceSensor {
    constructor() {
        super(...arguments);
        this.measuredValues = {};
    }
    handleNewMeasurement(instanceName, rssi, measuredPower, distance, outOfRange, batteryLevel) {
        this.measuredValues[instanceName] = new BluetoothLowEnergyMeasurement(rssi, measuredPower);
        this.handleNewDistance(instanceName, distance, outOfRange);
        if (batteryLevel !== undefined)
            this.batteryLevel = batteryLevel;
    }
}
exports.BluetoothLowEnergyPresenceSensor = BluetoothLowEnergyPresenceSensor;
//# sourceMappingURL=bluetooth-low-energy-presence.sensor.js.map