"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BluetoothLowEnergyConfig = void 0;
const numbers_1 = require("../../util/numbers");
const jf = __importStar(require("joiful"));
class TagOverride {
}
__decorate([
    (jf.string().optional()),
    __metadata("design:type", String)
], TagOverride.prototype, "id", void 0);
__decorate([
    (jf.string().optional()),
    __metadata("design:type", String)
], TagOverride.prototype, "name", void 0);
__decorate([
    (jf.number().negative().optional()),
    __metadata("design:type", Number)
], TagOverride.prototype, "measuredPower", void 0);
__decorate([
    (jf.number().integer().max(0xffffffff).optional()),
    __metadata("design:type", Number)
], TagOverride.prototype, "batteryMask", void 0);
class BluetoothLowEnergyConfig {
    constructor() {
        this.hciDeviceId = 0;
        this.whitelist = [];
        this.whitelistRegex = false;
        this.allowlist = [];
        this.allowlistRegex = false;
        this.blacklist = [];
        this.blacklistRegex = false;
        this.denylist = [];
        this.denylistRegex = false;
        this.processIBeacon = true;
        this.onlyIBeacon = false;
        this.majorMask = 0xffff;
        this.minorMask = 0xffff;
        this.batteryMask = 0x00000000;
        this.instanceBeaconEnabled = true;
        this.instanceBeaconMajor = 1;
        this.instanceBeaconMinor = (0, numbers_1.randomInt)(0, 65535);
        this.tagOverrides = {};
        this.timeout = 60;
        this.updateFrequency = 0;
        this.rssiFactor = 1;
        this.minDiscoveryLogRssi = -999;
    }
}
__decorate([
    (jf.number().integer().min(0).required()),
    __metadata("design:type", Object)
], BluetoothLowEnergyConfig.prototype, "hciDeviceId", void 0);
__decorate([
    (jf.array({ elementClass: String }).required()),
    __metadata("design:type", Array)
], BluetoothLowEnergyConfig.prototype, "whitelist", void 0);
__decorate([
    (jf.boolean().required()),
    __metadata("design:type", Object)
], BluetoothLowEnergyConfig.prototype, "whitelistRegex", void 0);
__decorate([
    (jf.array({ elementClass: String }).required()),
    __metadata("design:type", Array)
], BluetoothLowEnergyConfig.prototype, "allowlist", void 0);
__decorate([
    (jf.boolean().required()),
    __metadata("design:type", Object)
], BluetoothLowEnergyConfig.prototype, "allowlistRegex", void 0);
__decorate([
    (jf.array({ elementClass: String }).required()),
    __metadata("design:type", Array)
], BluetoothLowEnergyConfig.prototype, "blacklist", void 0);
__decorate([
    (jf.boolean().required()),
    __metadata("design:type", Object)
], BluetoothLowEnergyConfig.prototype, "blacklistRegex", void 0);
__decorate([
    (jf.array({ elementClass: String }).required()),
    __metadata("design:type", Array)
], BluetoothLowEnergyConfig.prototype, "denylist", void 0);
__decorate([
    (jf.boolean().required()),
    __metadata("design:type", Object)
], BluetoothLowEnergyConfig.prototype, "denylistRegex", void 0);
__decorate([
    (jf.boolean().required()),
    __metadata("design:type", Object)
], BluetoothLowEnergyConfig.prototype, "processIBeacon", void 0);
__decorate([
    (jf.boolean().required()),
    __metadata("design:type", Object)
], BluetoothLowEnergyConfig.prototype, "onlyIBeacon", void 0);
__decorate([
    (jf.number().integer().min(0).max(0xffff).required()),
    __metadata("design:type", Object)
], BluetoothLowEnergyConfig.prototype, "majorMask", void 0);
__decorate([
    (jf.number().integer().min(0).max(0xffff).required()),
    __metadata("design:type", Object)
], BluetoothLowEnergyConfig.prototype, "minorMask", void 0);
__decorate([
    (jf.number().integer().max(0xffffffff).required()),
    __metadata("design:type", Object)
], BluetoothLowEnergyConfig.prototype, "batteryMask", void 0);
__decorate([
    (jf.boolean().required()),
    __metadata("design:type", Object)
], BluetoothLowEnergyConfig.prototype, "instanceBeaconEnabled", void 0);
__decorate([
    (jf.number().integer().min(0).max(65535).required()),
    __metadata("design:type", Object)
], BluetoothLowEnergyConfig.prototype, "instanceBeaconMajor", void 0);
__decorate([
    (jf.number().integer().min(0).max(65535).required()),
    __metadata("design:type", Object)
], BluetoothLowEnergyConfig.prototype, "instanceBeaconMinor", void 0);
__decorate([
    (jf.object().custom(validateTagOverrides).required()),
    __metadata("design:type", Object)
], BluetoothLowEnergyConfig.prototype, "tagOverrides", void 0);
__decorate([
    (jf.number().min(0).required()),
    __metadata("design:type", Object)
], BluetoothLowEnergyConfig.prototype, "timeout", void 0);
__decorate([
    (jf.number().min(0).required()),
    __metadata("design:type", Object)
], BluetoothLowEnergyConfig.prototype, "updateFrequency", void 0);
__decorate([
    (jf.number().required()),
    __metadata("design:type", Object)
], BluetoothLowEnergyConfig.prototype, "rssiFactor", void 0);
__decorate([
    (jf.number().positive().optional()),
    __metadata("design:type", Number)
], BluetoothLowEnergyConfig.prototype, "maxDistance", void 0);
__decorate([
    (jf.number().max(0).required()),
    __metadata("design:type", Object)
], BluetoothLowEnergyConfig.prototype, "minDiscoveryLogRssi", void 0);
exports.BluetoothLowEnergyConfig = BluetoothLowEnergyConfig;
function validateTagOverrides(options) {
    return options.joi
        .object()
        .pattern(options.joi.string(), jf.getSchema(TagOverride));
}
//# sourceMappingURL=bluetooth-low-energy.config.js.map