"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Tag = void 0;
const lodash_1 = __importDefault(require("lodash"));
class Tag {
    constructor(peripheral) {
        this.isApp = false;
        this.peripheral = peripheral;
        this.rssi = peripheral.rssi;
        this.measuredPower = -59.0;
    }
    set id(id) {
        this._id = id;
    }
    get id() {
        return this._id || this.peripheral.id;
    }
    get name() {
        return this._name || this.peripheral.advertisement.localName || this.id;
    }
    set name(name) {
        this._name = name;
    }
    get distance() {
        if (this.rssi === 0) {
            return undefined;
        }
        const ratio = this.rssi / this.measuredPower;
        if (ratio < 1) {
            return lodash_1.default.round(Math.pow(ratio, 10), 1);
        }
        else {
            return lodash_1.default.round(0.89976 * Math.pow(ratio, 7.7095) + 0.111, 1);
        }
    }
}
exports.Tag = Tag;
//# sourceMappingURL=tag.js.map