import { OnApplicationBootstrap, OnApplicationShutdown } from '@nestjs/common';
import { EntitiesService } from '../../entities/entities.service';
import { ConfigService } from '../../config/config.service';
import { BinarySensor } from '../../entities/binary-sensor';
import { BinarySensorDeviceClass } from '../home-assistant/binary-sensor-config';
import { Switch } from '../../entities/switch';
export declare class GpioService implements OnApplicationBootstrap, OnApplicationShutdown {
    private readonly configService;
    private readonly entitiesService;
    private readonly config;
    private readonly logger;
    private readonly gpios;
    constructor(configService: ConfigService, entitiesService: EntitiesService);
    onApplicationBootstrap(): void;
    onApplicationShutdown(): void;
    protected createBinarySensor(name: string, pin: number, deviceClass?: BinarySensorDeviceClass): BinarySensor;
    protected createSwitch(name: string, pin: number, icon?: string): Switch;
}
