import { OnApplicationBootstrap, OnApplicationShutdown } from '@nestjs/common';
import { EntitiesService } from '../../entities/entities.service';
import { ThermopileOccupancyService } from '../../integration-support/thermopile/thermopile-occupancy.service';
import { ConfigService } from '../../config/config.service';
import { Camera } from '../../entities/camera';
export declare class GridEyeService extends ThermopileOccupancyService implements OnApplicationBootstrap, OnApplicationShutdown {
    private readonly entitiesService;
    private readonly configService;
    private readonly config;
    private readonly logger;
    private i2cBus;
    private sensor;
    private camera;
    private readonly heatmapMutex;
    constructor(entitiesService: EntitiesService, configService: ConfigService);
    onApplicationBootstrap(): Promise<void>;
    onApplicationShutdown(): Promise<void>;
    updateState(): Promise<void>;
    getPixelTemperatures(): Promise<number[][]>;
    maskZeroBasedValues(temperatures: number[][]): Promise<number[][]>;
    getPixelTemperature(pixelAddr: number): Promise<number>;
    getRegister(register: number, length: number): Promise<number>;
    setRegister(register: number, value: number): Promise<void>;
    private createSensor;
    protected createHeatmapCamera(): Camera;
}
