import { Device } from './device';
export declare const PROPERTY_DENYLIST: string[];
export declare type AvailabilityStatus = 'online' | 'offline';
declare type AvailabilityMode = 'all' | 'any' | 'latest';
export declare class Availability {
    topic: string;
    payloadAvailable: AvailabilityStatus;
    payloadNotAvailable: AvailabilityStatus;
    constructor(topic: string);
}
export declare enum StateClass {
    MEASUREMENT = "measurement",
    TOTAL_INCREASING = "total_increasing"
}
export declare abstract class EntityConfig {
    uniqueId: string;
    component: string;
    name: string;
    device: Device;
    configTopic: string;
    stateTopic: string;
    jsonAttributesTopic: string;
    availabilityMode: AvailabilityMode;
    stateClass?: StateClass;
    distributed: boolean;
    stateLocked: boolean;
    private _instanceStatusTopic;
    private readonly _entityStatusTopic;
    protected constructor(component: string, id: string, name: string, device?: Device);
    get availability(): Array<Availability>;
    setInstanceStatusTopic(topic: string): void;
    shallowClone(): Record<string, unknown>;
}
export {};
