"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EntityConfig = exports.StateClass = exports.Availability = exports.PROPERTY_DENYLIST = void 0;
exports.PROPERTY_DENYLIST = [
    'component',
    'configTopic',
    'commandStore',
    '_instanceStatusTopic',
    '_entityStatusTopic',
    'distributed',
    'stateLocked',
];
class Availability {
    constructor(topic) {
        this.topic = topic;
        this.payloadAvailable = 'online';
        this.payloadNotAvailable = 'offline';
    }
}
exports.Availability = Availability;
var StateClass;
(function (StateClass) {
    StateClass["MEASUREMENT"] = "measurement";
    StateClass["TOTAL_INCREASING"] = "total_increasing";
})(StateClass = exports.StateClass || (exports.StateClass = {}));
class EntityConfig {
    constructor(component, id, name, device) {
        this.availabilityMode = 'all';
        this.distributed = false;
        this.stateLocked = true;
        this.component = component;
        this.name = name;
        this.device = device;
        this.uniqueId = `room-assistant-${id}`;
        this.configTopic = `${this.component}/room-assistant/${id}/config`;
        this.stateTopic = `room-assistant/${this.component}/${id}/state`;
        this.jsonAttributesTopic = `room-assistant/${this.component}/${id}/attributes`;
        this._entityStatusTopic = `room-assistant/${this.component}/${id}/status`;
    }
    get availability() {
        if (this.distributed && !this.stateLocked) {
            return [];
        }
        else {
            return [
                new Availability(this._entityStatusTopic),
                new Availability(this._instanceStatusTopic),
            ];
        }
    }
    setInstanceStatusTopic(topic) {
        this._instanceStatusTopic = topic;
    }
    shallowClone() {
        const clone = Object.assign({}, this);
        clone.availability = this.availability;
        return clone;
    }
}
exports.EntityConfig = EntityConfig;
//# sourceMappingURL=entity-config.js.map