"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MqttHealthIndicator = void 0;
const terminus_1 = require("@nestjs/terminus");
const common_1 = require("@nestjs/common");
const mqtt_service_1 = require("./mqtt.service");
const health_indicator_service_1 = require("../../status/health-indicator.service");
let MqttHealthIndicator = class MqttHealthIndicator extends terminus_1.HealthIndicator {
    constructor(mqttService, healthIndicatorService) {
        super();
        this.mqttService = mqttService;
        healthIndicatorService === null || healthIndicatorService === void 0 ? void 0 : healthIndicatorService.registerHealthIndicator(async () => this.connectionCheck());
    }
    connectionCheck() {
        const isHealthy = this.mqttService.isConnected();
        const result = this.getStatus('mqtt_connected', isHealthy);
        if (isHealthy) {
            return result;
        }
        throw new terminus_1.HealthCheckError('No connection to MQTT broker', result);
    }
};
MqttHealthIndicator = __decorate([
    (0, common_1.Injectable)(),
    __param(1, (0, common_1.Optional)()),
    __metadata("design:paramtypes", [mqtt_service_1.MqttService, health_indicator_service_1.HealthIndicatorService])
], MqttHealthIndicator);
exports.MqttHealthIndicator = MqttHealthIndicator;
//# sourceMappingURL=mqtt.health.js.map