/// <reference types="node" />
import { OnApplicationBootstrap, OnApplicationShutdown } from '@nestjs/common';
import { EntitiesService } from '../../entities/entities.service';
import { ConfigService } from '../../config/config.service';
import { Sensor } from '../../entities/sensor';
import { ThermopileOccupancyService } from '../../integration-support/thermopile/thermopile-occupancy.service';
import { Camera } from '../../entities/camera';
export declare class OmronD6tService extends ThermopileOccupancyService implements OnApplicationBootstrap, OnApplicationShutdown {
    private readonly entitiesService;
    private readonly configService;
    private readonly config;
    private i2cBus;
    private sensor;
    private camera;
    private readonly heatmapMutex;
    private readonly logger;
    constructor(entitiesService: EntitiesService, configService: ConfigService);
    onApplicationBootstrap(): Promise<void>;
    onApplicationShutdown(): Promise<void>;
    updateState(): Promise<void>;
    getPixelTemperatures(): Promise<number[][]>;
    checkPEC(buffer: Buffer, pecIndex: number): boolean;
    calculateCRC(data: number): number;
    protected createSensor(): Sensor;
    protected createHeatmapCamera(): Camera;
}
