"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ShellSwitch = void 0;
const switch_1 = require("../../entities/switch");
const util = __importStar(require("util"));
const child_process_1 = require("child_process");
const common_1 = require("@nestjs/common");
const execPromise = util.promisify(child_process_1.exec);
class ShellSwitch extends switch_1.Switch {
    constructor(id, name, onCommand, offCommand) {
        super(id, name, false);
        this.onCommand = onCommand;
        this.offCommand = offCommand;
    }
    async turnOn() {
        try {
            await execPromise(this.onCommand);
            super.turnOn();
        }
        catch (e) {
            common_1.Logger.error(`Turning ${this.id} on failed: ${e.message}`, e.stack, ShellSwitch.name);
        }
    }
    async turnOff() {
        try {
            await execPromise(this.offCommand);
            super.turnOff();
        }
        catch (e) {
            common_1.Logger.error(`Turning ${this.id} off failed: ${e.message}`, e.stack, ShellSwitch.name);
        }
    }
}
exports.ShellSwitch = ShellSwitch;
//# sourceMappingURL=shell.switch.js.map