import { OnApplicationBootstrap, OnModuleInit } from '@nestjs/common';
import { Peripheral } from '@mkerix/noble';
import { EntitiesService } from '../../entities/entities.service';
import { ConfigService } from '../../config/config.service';
import { Device } from '../home-assistant/device';
import { BluetoothService } from '../../integration-support/bluetooth/bluetooth.service';
export declare class XiaomiMiService implements OnModuleInit, OnApplicationBootstrap {
    private readonly bluetoothService;
    private readonly entitiesService;
    private readonly configService;
    private readonly logger;
    private config;
    private lastFrameSeen;
    private batterySchedule;
    constructor(bluetoothService: BluetoothService, entitiesService: EntitiesService, configService: ConfigService);
    onModuleInit(): void;
    onApplicationBootstrap(): void;
    private hasSensors;
    private recordMeasure;
    handleDiscovery(peripheral: Peripheral): Promise<void>;
    private parseAdvertisement;
    private static findServiceData;
    private static parseServiceData;
    checkMifloraBattery(peripheral: Peripheral, device: Device): Promise<void>;
}
