import { HealthCheckResult, HealthCheckService, HealthIndicatorFunction } from '@nestjs/terminus';
import { OnApplicationBootstrap, OnModuleDestroy } from '@nestjs/common';
import { SchedulerRegistry } from '@nestjs/schedule';
export declare class HealthIndicatorService implements OnApplicationBootstrap, OnModuleDestroy {
    private readonly health;
    private readonly schedulerRegistry;
    private healthIndicators;
    private readonly logger;
    constructor(health: HealthCheckService, schedulerRegistry: SchedulerRegistry);
    onApplicationBootstrap(): void;
    onModuleDestroy(): void;
    getIndicators(): HealthIndicatorFunction[];
    registerHealthIndicator(healthIndicatorFunction: HealthIndicatorFunction): void;
    check(): Promise<HealthCheckResult>;
    private updateWatchdog;
}
