"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.KalmanFilterable = void 0;
const kalmanjs_1 = __importDefault(require("kalmanjs"));
function KalmanFilterable(Base, R = 1, Q = 1) {
    return class extends Base {
        constructor() {
            super(...arguments);
            this.kalmanFilterMap = new Map();
        }
        kalmanFilter(value, id = 'default') {
            if (this.kalmanFilterMap.has(id)) {
                return this.kalmanFilterMap.get(id).filter(value);
            }
            else {
                const kalman = new kalmanjs_1.default({ R, Q });
                this.kalmanFilterMap.set(id, kalman);
                return kalman.filter(value);
            }
        }
    };
}
exports.KalmanFilterable = KalmanFilterable;
//# sourceMappingURL=filters.js.map